#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>

#include "TRandom3.h" 

#include "CRootManager.hh"
#include "CDataSample.hh"

static const int N = 10000;

int main()
{
  TRandom3* random = new TRandom3;
  random->SetSeed();

  CRootManager* root = new CRootManager;
  CDataSample* data = new CDataSample;

  for(int runnumber = 0; runnumber < 10; ++runnumber){
    std::cout << "run:" << runnumber << std::endl;

    root->Reset();

    std::ostringstream oss;
    oss << "root/run" << std::setw(4) << std::setfill('0') << runnumber << ".root";
    root->CreateFile(oss.str().c_str(), "recreate");
    root->CreateTree("Koyomi", "Koyomi is Hero of Bakemono-Gatari");
    root->CreateBranch("branchname", &data);

    for(int i = 0; i < N; ++i){
      double x,y,z;
      double r = random->Rndm();
      random->Sphere(x,y,z,r);

      data->x = x;
      data->y = y;
      data->z = z;      
      data->r = r;
      data->eventflag = random->Integer(2);

      root->Fill();
    }
    root->Write();
  }

  delete random;
  delete data;
  delete root;

  return 0;
}
