#include <iostream>
#include <string>
#include <cstring>
#include <vector>

#include "TFile.h"
#include "TTree.h"
#include "TBranch.h"

#include "CRootManager.hh"

CRootManager::CRootManager() : tree_v()
{
  file = 0;
}

CRootManager::~CRootManager()
{;}

void CRootManager::Reset()
{
  DeleteTree();
  DeleteFile();
}  

TFile* CRootManager::CreateFile(std::string filename, std::string option)
{
  if(file){
    std::cout << "some file is already opened" << std::endl;
    return file;
  }else{
    return file = new TFile(filename.c_str(), option.c_str());
  }
}

TTree* CRootManager::CreateTree(std::string treename, std::string title)
{
  TTree* t = new TTree(treename.c_str(), title.c_str());
  tree_v.push_back(t);

  return t;
}

void CRootManager::Fill()
{
  std::vector<TTree*>::iterator it = tree_v.begin();
  while(it != tree_v.end()){
    (*it)->Fill();
    ++it;
  }
}

void CRootManager::Fill(std::string treename)
{
  TTree* t = GetTree(treename);
  if(t) t->Fill();
}

void CRootManager::Write()
{
  std::vector<TTree*>::iterator it = tree_v.begin();
  while(it != tree_v.end()){
    (*it)->Write();
    ++it;
  }
}

void CRootManager::Write(std::string treename)
{
  TTree* t = GetTree(treename);
  if(t) t->Write();
}

TFile* CRootManager::GetFile()
{
  return file;
}

TTree* CRootManager::GetTree(std::string treename)
{
  std::vector<TTree*>::iterator it = tree_v.begin();
  if(tree_v.begin() == tree_v.end()){
    return 0;
  }

  if(treename.empty()){
    return *it;
  }

  while(it != tree_v.end()){
    if(strcmp((*it)->GetName(), treename.c_str()) == 0) break;
    ++it;
  }
  
  if(it == tree_v.end()){
    std::cout << treename << " doesn't exist" << std::endl;
    return 0;
  }

  return *it;
}

void CRootManager::DeleteFile()
{
  delete file;
  file = 0;
}

void CRootManager::DeleteTree()
{
  std::vector<TTree*>::iterator it = tree_v.begin();
  while(it != tree_v.end()){
    delete *it;
    ++it;
  }
  tree_v.clear();
}

